#!/bin/sh

. /etc/PG.conf

# create custom appgroup 
ddos_name="sysalert_ddos"
ddos_cname="澯_ɨDDOS"
floweye agp remove ${ddos_name}
floweye agp add name=${ddos_name} cname=${ddos_cname} >/dev/null 2>&1
floweye agp load ${ddos_name} app=ntp app=msds app=upnp >/dev/null 2>&1

ra_name="sysalert_rmteaccess"
ra_cname="澯_Զ̷"
floweye agp remove ${ra_name}
floweye agp add name=${ra_name} cname=${ra_cname} >/dev/null 2>&1
floweye agp load ${ra_name} app=ssh app=telnet app=teamviewer app=xiangrikuiyk app=pcanywhere >/dev/null 2>&1

fr_name="sysalert_filetransf"
fr_cname="澯_ļ"
floweye agp remove ${fr_name}
floweye agp add name=${fr_name} cname=${fr_cname} >/dev/null 2>&1
floweye agp load ${fr_name} app=ftp app=tftp app=pop3 app=smtp app=imap >/dev/null 2>&1

# Default policy list
defrule="evtype=cpu,evattr=cpurate,objname=any,opcode=above,limit1=80,dura=30"
defrule="${defrule} evtype=auth,evattr=authleft,objname=any,opcode=below,limit1=7,dura=0,notifyinter=86400"
defrule="${defrule} evtype=syn,evattr=synpps_synackpps_ratio,objname=any,opcode=above,limit1=30,dura=30,notifyinter=300"

# There are no restrictions on NTM professional version licensing
res=`floweye ntm stat | grep "ntmfree=1"`
if [ "X${res}" != "X" -o "X${NTM}" = "X" ]; then
	defrule="${defrule} evtype=flow,evattr=flowsum_usepercent,objname=any,opcode=above,limit1=95,dura=30,notifyinter=3600"
	defrule="${defrule} evtype=ip,evattr=ipsum_usepercent,objname=any,opcode=above,limit1=95,dura=30,notifyinter=3600"
fi

defrule="${defrule} evtype=if,evattr=ifinbps_usepercent,objname=any,opcode=above,limit1=90,dura=30,notifyinter=3600"
defrule="${defrule} evtype=if,evattr=ifoutbps_usepercent,objname=any,opcode=above,limit1=90,dura=30,notifyinter=3600"
defrule="${defrule} evtype=if,evattr=ifstat,objname=any,opcode=monitorstat,limit1=0,dura=0,notifyinter=0"
defrule="${defrule} evtype=localip,evattr=localipflowcnt,objname=any,opcode=above,limit1=5000,dura=30,notifyinter=3600"
defrule="${defrule} evtype=localip,evattr=localip_sessionapp,objname=any,opcode=match,limit1=bitcoin,dura=1,notifyinter=3600"
if [ "${NTM}" = "1" ]; then
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=digiccy,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=c2,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=apt,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=webshell,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=phishing,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=bot,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=malware,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=scanner,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=tor,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=proxy,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=downloader,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=mc_website,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=porn,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=gambling,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=spam,opcode=monitorstat,dura=0,notifyinter=300"
	defrule="${defrule} evtype=malicious,evattr=malcmatch,objname=suspicious,opcode=monitorstat,dura=0,notifyinter=300"
fi
defrule="${defrule} evtype=app,evattr=appflowcnt,objname=${ra_name},opcode=above,limit1=1,dura=1,notifyinter=1,monitor_hour=21-9"
defrule="${defrule} evtype=app,evattr=appupbps,objname=${fr_name},opcode=above,limit1=10000,dura=1,notifyinter=1,monitor_hour=21-9"
defrule="${defrule} evtype=app,evattr=appflowcnt,objname=${ddos_name},opcode=above,limit1=5000,dura=1,notifyinter=1"

# Restore default policy
if [ "$1" = "restore" ]; then
	# Remove all system default rules
	if [ "$#" = "1" ]; then
		floweye nevt_rule remove utag=1
	else
		# ./cmd.sh restore id=n evtype=if evattr=ifstat objname=any opcode=above
		if [ "$#" = "6" ]; then
			param="$3,$4,$5,$6"
			for rule in ${defrule}; do
				str=`echo ${rule} | grep ${param}`
				if [ "X${str}" != "X" ]; then
					format_str=`echo ${rule} | sed 's/,/ /g'`
					floweye nevt_rule set ${2} ${format_str} alarm_level=2 utag=1 nontrig=0
					break
				fi
			done
		fi
		exit
	fi
fi

# Get the max rule_id of current rule list
maxid=`floweye nevt_rule get get_maxid=1`
[ "${maxid}" = "" ] && maxid=0

# Empty policy
if [ "${maxid}" = "0" ]; then
	for rule in ${defrule}; do
		maxid=$((${maxid} + 1))
		format_str=`echo ${rule} | sed 's/,/ /g'`
		floweye nevt_rule add id=${maxid} ${format_str} alarm_level=2 utag=1 nontrig=0
	done
else
	# When there is already a policy in the system, 
	# we will increment from the maximum ID number as the ID number of the new policy
	actrule=""
	rulelist=`floweye nevt_rule list json=0 utag=1 | awk '{print $4,$5,$6,$9}'`
	while read type attr opcode objname; do
		actrule="${actrule} evtype=${type},evattr=${attr},objname=${objname},opcode=${opcode}"
	done << EOF
		${rulelist}
EOF
	
	for str in ${defrule}; do
		# Check whether the policy exists
		exist=""
		for act in ${actrule}; do
			exist=`echo ${str} | grep ${act}`
			[ "$?" = "0" ] && break
		done

		if [ "X${exist}" = "X" ]; then
			while true; do
				maxid=$((${maxid} + 1))
				[ ${maxid} -ge 65535 ] && maxid=0
				format_str=`echo ${str} | sed 's/,/ /g'`
				floweye nevt_rule add id=${maxid} ${format_str} alarm_level=2 utag=1 nontrig=0 >/dev/null
				[ "$?" = "0" ] && break
			done
		fi
	done
fi
